package com.nisum.asegers.docker_k8_employee_service.controller;

import com.nisum.asegers.docker_k8_employee_service.exception.ResourceNotFoundException;
import com.nisum.asegers.docker_k8_employee_service.model.Employee;
import com.nisum.asegers.docker_k8_employee_service.service.EmployeeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("/api/v1/employees")
public class EmployeeController {
    @Autowired
    EmployeeService employeeService;

    @GetMapping("/")
    public ResponseEntity<List<Employee>> getAllEmployees() {
        return ResponseEntity.ok().body(employeeService.getAllEmployees());
    }

    @GetMapping("/{id}")
    public ResponseEntity<Employee> getAllEmployees(@PathVariable(value= "id") Long id) throws ResourceNotFoundException {
        Employee employee =  employeeService.getEmployeeById(id)
                .orElseThrow(() ->  new ResourceNotFoundException("Employee with id: " + id + " does not exit"));
        return ResponseEntity.ok().body(employee);
    }
}
