package com.nisum.asegers.docker_k8_employee_service.repository.seeder;

import com.github.javafaker.Faker;
import com.nisum.asegers.docker_k8_employee_service.model.Employee;
import com.nisum.asegers.docker_k8_employee_service.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;

@Component
public class Seeder {
    @Autowired
    EmployeeRepository employeeRepository;

    @EventListener
    public void seed(ContextRefreshedEvent event) {
        seedEmployees(10);
    }

    private Employee generateEmployee() {
        Faker faker  = new Faker();
        Employee employee = new Employee();
        employee.setFirstName(faker.name().firstName());
        employee.setLastName(faker.name().lastName());
        return employee;
    }

    public void seedEmployees(int count) {
        for (int n = 0; n < count; n++)
            employeeRepository.save(generateEmployee());
    }
}
